﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Cyanigosa"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 588 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.otherMenu = "Dalaran"
mod.zonename = BZ["The Violet Hold"]
mod.enabletrigger = boss
mod.guid = 31134
mod.toggleOptions = {"blizzard", -1, "vacuum", "vacuumcooldown", -1, "destruction", "destructionBar", "bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	blizzard = "Blizzard",
	blizzard_desc = "Warns for Blizzard.",
	blizzard_message = "Blizzard",
	cmd = "Cyanigosa",
	destruction = "Mana Destruction",
	destructionBar = "Mana Destruction Bar",
	destructionBar_desc = "Display a bar for the duration of Mana Destruction.",
	destruction_desc = "Warn when someone has Mana Destruction.",
	destruction_message = "%s: %s",
	vacuum = "Arcane Vacuum",
	vacuumcooldown = "Arcane Vacuum cooldown",
	vacuum_cooldown_bar = "Arcane Vacuum cooldown",
	vacuumcooldown_desc = "Warn when cooldown for Arcane Vacuum has passed.",
	vacuum_desc = "Warns for Arcane Vacuum.",
	vacuum_message = "Arcane Vacuum",
	vacuum_soon = "Arcane Vacuum in ~5sec",
}

end )

L:RegisterTranslations("deDE", function() return {
	blizzard = "Blizzard",
	blizzard_desc = "Warnung für den Blizzard.",
	blizzard_message = "Blizzard!",
	cmd = "Cyanigosa",
	destruction = "Manazerstörung",
	destructionBar = "Manazerstörung-Anzeige",
	destructionBar_desc = "Eine Leiste für die Dauer von Manazerstörung anzeigen.",
	destruction_desc = "Warnung wenn jemand von Manazerstörung betroffen ist.",
	destruction_message = "%s: %s",
	vacuum = "Arkanes Vakuum",
	vacuumcooldown = "Arkanes Vakuum-Cooldown",
	vacuum_cooldown_bar = "Arkanes Vakuum-Cooldown",
	vacuumcooldown_desc = "Warnung wenn der Cooldown für Arkanes Vakuum vorüber ist.",
	vacuum_desc = "Warnung für Arkanes Vakuum.",
	vacuum_message = "Arkanes Vakuum",
	vacuum_soon = "Arkanes Vakuum in ~5sek",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	blizzard = "Blizzard",
	blizzard_desc = "Prévient quand un Blizzard est incanté.",
	blizzard_message = "Blizzard",
	cmd = "Cyanigosa",
	destruction = "Destruction du mana",
	destructionBar = "Destruction du mana - Barre",
	destructionBar_desc = "Affiche une barre indiquant la durée de la Destruction du mana.",
	destruction_desc = "Prévient quand un joueur subit les effets de la Destruction du mana.",
	destruction_message = "%s : %s",
	vacuum = "Vide des arcanes",
	vacuumcooldown = "Vide des arcanes - Recharge",
	vacuum_cooldown_bar = "Recharge Vide des arcanes",
	vacuumcooldown_desc = "Affiche une barre indiquant le temps de recharge du Vide des arcanes.",
	vacuum_desc = "Prévient un Vide des arcanes est incanté.",
	vacuum_message = "Vide des arcanes",
	vacuum_soon = "Vide des arcanes dans ~5sec !",
}

end )

L:RegisterTranslations("koKR", function() return {
	blizzard = "눈보라",
	blizzard_desc = "눈보라에 대해 알립니다.",
	blizzard_message = "눈보라!",
	cmd = "시아니고사",
	destruction = "마나 파괴",
	destructionBar = "마나 파괴 바",
	destructionBar_desc = "마나 파괴가 지속되는 바를 표시합니다.",
	destruction_desc = "마나 파괴에 걸린 플레이어를 알립니다.",
	destruction_message = "%s: %s",
	vacuum = "비전 진공",
	vacuumcooldown = "비전 진공 대기시간",
	vacuum_cooldown_bar = "비전 진공 대기시간",
	vacuumcooldown_desc = "비전 진공의 대기시간 바를 표시합니다.",
	vacuum_desc = "비전 진공에 대해 알립니다.",
	vacuum_message = "비전 진공!",
	vacuum_soon = "약 5초 후 비전 진공!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	blizzard = "Снежная буря",
	blizzard_desc = "Предупреждать о Снежной буре.",
	blizzard_message = "Снежная буря!",
	cmd = "Cyanigosa",
	destruction = "Захват маны",
	destructionBar = "Полоса Захвата маны",
	destructionBar_desc = "Отображать полосу продолжительности Захвата маны.",
	destruction_desc = "Сообщать о получении кем-либо Захвата маны.",
	destruction_message = "%s: %s",
	vacuum = "Чародейский вакуум",
	vacuumcooldown = "Перезарядка Чародейского вакуума",
	vacuum_cooldown_bar = "Перезарядка вакуума",
	vacuumcooldown_desc = "Предупреждать о завершении перезарядки Чародейского вакуума.",
	vacuum_desc = "Предупреждать о Чародейском вакууме.",
	vacuum_message = "Чародейский вакуум!",
	vacuum_soon = "Чародейский вакуум через ~5сек!",
}

end )

L:RegisterTranslations("zhCN", function() return {
	blizzard = "暴风雪",
	blizzard_desc = "当施放暴风雪时发出警报。",
	blizzard_message = "暴风雪！",
	destruction = "法力毁灭",
	destructionBar = "法力毁灭计时条",
	destructionBar_desc = "当法力毁灭持续时显示计时条。",
	destruction_desc = "当玩家中了法力毁灭时发出警报。",
	destruction_message = "%s：%s！",
	vacuum = "奥术真空",
	vacuumcooldown = "奥术真空冷却",
	vacuum_cooldown_bar = "<奥术真空 冷却>",
	vacuumcooldown_desc = "当奥术真空冷却结束时发出警报。",
	vacuum_desc = "当施放奥术真空时发出警报。.",
	vacuum_message = "奥术真空！",
	vacuum_soon = "约5秒后，奥术真空！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	blizzard = "暴風雪",
	blizzard_desc = "當施放暴風雪時發出警報。",
	blizzard_message = "暴風雪！",
	cmd = "霞妮苟莎",
	destruction = "法力浩劫",
	destructionBar = "法力浩劫計時條",
	destructionBar_desc = "當法力浩劫持續時顯示計時條。",
	destruction_desc = "當玩家中了法力浩劫時發出警報。",
	destruction_message = "%s：%s！",
	vacuum = "秘法真空",
	vacuumcooldown = "秘法真空冷卻",
	vacuum_cooldown_bar = "<秘法真空 冷卻>",
	vacuumcooldown_desc = "當秘法真空冷卻結束時發出警報。",
	vacuum_desc = "當施放秘法真空時發出警報。",
	vacuum_message = "秘法真空！",
	vacuum_soon = "約5秒後，秘法真空！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Vacuum", 58694)
	self:AddCombatListener("SPELL_CAST_SUCCESS", "Blizzard", 58693, 59369)
	self:AddCombatListener("SPELL_AURA_APPLIED", "Destruction", 59374)
	self:AddCombatListener("SPELL_AURA_REMOVED", "DestructionRemoved", 59374)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
	
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "CheckForWipe")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "CheckForEngage")
	self:RegisterEvent("BigWigs_RecvSync")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Vacuum(_, spellId)
	if self.db.profile.vacuum then
		self:IfMessage(L["vacuum_message"], "Important", spellId)
	end
	if self.db.profile.vacuumcooldown then
		self:TriggerEvent("BigWigs_StopBar", self, L["vacuum_cooldown_bar"])
		self:CancelScheduledEvent("VacuumWarn")
		self:Bar(L["vacuum_cooldown_bar"], 30, 58694)
		self:ScheduleEvent("VacuumWarn", "BigWigs_Message", 25, L["vacuum_soon"], "Urgent")
	end
end

function mod:Blizzard(_, spellId)
	if self.db.profile.blizzard then
		self:IfMessage(L["blizzard_message"], "Important", spellId)
	end
end

function mod:Destruction(player, spellId, _, _, spellName)
	if self.db.profile.destruction then
		self:IfMessage(L["destruction_message"]:format(spellName, player), "Important", spellId)
	end
	if self.db.profile.destructionBar then
		self:Bar(L["destruction_message"]:format(spellName, player), 8, spellId)
	end
end

function mod:DestructionRemoved(player, _, _, _, spellName)
	if self.db.profile.destructionBar then
		self:TriggerEvent("BigWigs_StopBar", self, L["destruction_message"]:format(spellName, player))
	end
end

function mod:BigWigs_RecvSync(sync, rest, nick)
	if self:ValidateEngageSync(sync, rest) and not started then
		if self:IsEventRegistered("PLAYER_REGEN_DISABLED") then
			self:UnregisterEvent("PLAYER_REGEN_DISABLED")
		end
		if self.db.profile.vacuumcooldown then
			self:Bar(L["vacuum_cooldown_bar"], 30, 58694)
			self:ScheduleEvent("VacuumWarn", "BigWigs_Message", 25, L["vacuum_soon"], "Urgent")
		end
	end
end
