﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Argent Confessor Paletress"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 550 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "Icecrown"
mod.zonename = BZ["Trial of the Champion"]
mod.enabletrigger = boss
mod.guid = 34928
mod.toggleOptions = {"shield", "healing", "bosskill"}

--------------------------------
--           Locals           --
--------------------------------

local shielded = false

--------------------------------
--        Localization        --
--------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Argent Confessor Paletress",
	heal_msg = "Paletress is healing!",
	shield = "Reflective Shield",
	shield_desc = "Warn when Paletress gains Reflective Shield.",
	shield_gain = "Reflective Shield up!",
	shield_lost = "Shield faded",
	trigger_surrender = "Excellent work!",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Argentumbeichtpatin Blondlocke",
	heal_msg = "Blondlocke heilt sich!",
	shield = "Reflektierender Schild",
	shield_desc = "Warnen wenn Argentumbeichtpatin Blondlocke ihr Reflektierendes Schild erhält.",
	shield_gain = "Reflektierender Schild aktiv!",
	shield_lost = "Schild abgelaufen!",
	trigger_surrender = "Exzellente Arbeit!", -- Needs review
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Confesseur d'argent Paletress",
	heal_msg = "Paletress soigne !",
	shield = "Bouclier réflecteur",
	shield_desc = "Prévient quand Paletress gagne Bouclier réflecteur.",
	shield_gain = "Bouclier réflecteur actif !",
	shield_lost = "Bouclier dissipé",
	trigger_surrender = "C'est du beau travail !",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "은빛 고해사제 페일트리스",
	heal_msg = "페일트리스 소생 시전!",
	shield = "반사의 보호막",
	shield_desc = "반사의 보호막 활성화를 알립니다.",
	shield_gain = "반사의 보호막 활성화!",
	shield_lost = "반사의 보호막 사라짐",
	trigger_surrender = "훌륭히 해내셨군요!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	heal_msg = "Пейлтресс исцеляется!",
	shield = "Отражающий щит!",
	shield_desc = "Предупреждать об Отражающем щите",
	shield_gain = "Применён щит!",
	shield_lost = "Щит рассеялся",
}

end )

L:RegisterTranslations("zhCN", function() return {
	heal_msg = "帕尔崔丝 - 正在治疗！",
	shield = "Reflective Shield", -- Needs review
	shield_desc = "当帕尔崔丝获得Reflective Shield时发出警报。", -- Needs review
	shield_gain = "Reflective Shield！", -- Needs review
	shield_lost = "Reflective Shield 消失！", -- Needs review
	trigger_surrender = "缺失", -- Needs review
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "銀白告解者帕爾璀絲",
	heal_msg = "帕爾璀絲 - 正在治療！",
	shield = "反射護盾",
	shield_desc = "當帕爾璀絲獲得反射護盾時發出警告。",
	shield_gain = "反射護盾！",
	shield_lost = "反射護盾 消失！",
	trigger_surrender = "你們做得很好!",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "ShieldGain", 66515)
	self:AddCombatListener("SPELL_AURA_REMOVED", "ShieldLost", 66515)
	self:AddCombatListener("SPELL_CAST_START", "Renew", 66537, 67675)
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
	--self:AddCombatListener("UNIT_DIED", "BossDeath")
	
	shielded = false
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:ShieldGain(_, spellId, _, _, spellName)
	if self.db.profile.shield then
		self:IfMessage(L["shield_gain"], "Urgent", spellId)
	end
	shielded = true
end

function mod:ShieldLost(_, spellId, _, _, spellName)
	if self.db.profile.shield then
		self:IfMessage(L["shield_lost"], "Urgent", spellId)
	end
	shielded = false
end

function mod:Renew(_, spellId, _, _, spellName)
	-- don't bother announcing while she is shielded
	if not shielded and self.db.profile.healing then
		self:IfMessage(L["heal_msg"], "Urgent", spellId)
	end
end

function mod:CHAT_MSG_MONSTER_YELL(msg)
	if msg == L["trigger_surrender"] then
		self:BossDeath(nil, self.guid)
	end
end
