﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["The Black Knight"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 550 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "Icecrown"
mod.zonename = BZ["Trial of the Champion"]
mod.enabletrigger = boss
mod.guid = 35451
mod.toggleOptions = {"explode", "explodeBar", "desecration", "bosskill"}

--------------------------------
--       Are you local?       --
--------------------------------

local deaths = 0
local pName = UnitName("player")

--------------------------------
--        Localization        --
--------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "The Black Knight",
	desecration = "Desecration",
	desecration_desc = "Warn when Desecration is on you.",
	explode = "Ghoul Explode",
	explodeBar = "Ghoul Explode Bar",
	explodeBar_desc = "Display a casting bar for Ghoul Explode.",
	explode_desc = "Warn when The Black Knight is going to shatter his ghouls.",
	explode_message = "Casting Ghoul Explode!",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Der Schwarze Ritter",
	desecration = "Entweihung",
	desecration_desc = "Warnt wenn du auf entweihtem Boden stehst",
	explode = "Ghulexplosion",
	explodeBar = "Ghulexplosion-Leiste",
	explodeBar_desc = "Eine Zauberleiste für die Ghulexplosion anzeigen.",
	explode_desc = "Warnen wenn der Schwarze Ritter seine Ghouls explodieren lässt.",
	explode_message = "Zaubert Ghulexplosion!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Le Chevalier noir",
	desecration = "Violation",
	desecration_desc = "Prévient quand vous vous trouvez dans une Violation.",
	explode = "Explosion de goule",
	explodeBar = "Explosion de goule - Barre",
	explodeBar_desc = "Affiche une barre d'incantation pour l'Explosion de goule.",
	explode_desc = "Prévient quand le Chevalier noir est sur le point de faire exploser ses goules.",
	explode_message = "Explosion de goule en incantation !",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "흑기사",
	desecration = "모독",
	desecration_desc = "모독 대상일 경우 경보",
	explode = "구울 폭발",
	explodeBar = "구울 폭발 바",
	explodeBar_desc = "구울 폭발 시전바를 표시합니다.",
	explode_desc = "흑기사의 구울 폭발을 알립니다.",
	explode_message = "구울 폭발 시전!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	desecration = "Осквернение",
	desecration_desc = "Сообщать если Осквернение на вас.",
	explode = "Взрыв вурдалака",
	explodeBar = "Полоса Взрыва вурдалака",
	explodeBar_desc = "Отображать полосу применения Взрыва вурдалака.",
	explode_desc = "Предупреждать когда Черный рыцарь взрывает приспешника-вурдалака.",
	explode_message = "Применение Взрыва вурдалака!",
}

end )

L:RegisterTranslations("zhCN", function() return {
	desecration = "亵渎",
	desecration_desc = "当你中了亵渎时发出警报。",
	explode = "食尸鬼爆炸",
	explodeBar = "食尸鬼爆炸计时条",
	explodeBar_desc = "当正在施放食尸鬼爆炸时显示计时条。",
	explode_desc = "当黑骑士粉碎他的食尸鬼时发出警报。",
	explode_message = "正在施放 食尸鬼爆炸！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "黑騎士",
	desecration = "褻瀆",
	desecration_desc = "當你中了褻瀆時發出警報。",
	explode = "食屍鬼爆炸",
	explodeBar = "食屍鬼爆炸計時條",
	explodeBar_desc = "當正在施放食屍鬼爆炸時顯示計時條。",
	explode_desc = "當黑騎士準備粉碎他的食屍鬼時發出警報。",
	explode_message = "正在施放 食屍鬼爆炸！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_START", "Explode", 67751)-- other possible ids :  67886, 51874, 47496, 67729,
	self:AddCombatListener("SPELL_AURA_APPLIED", "Desecration", 67781, 67876)
	self:AddCombatListener("UNIT_DIED", "Deaths")

	self:RegisterEvent("PLAYER_REGEN_ENABLED", "CheckForWipe")

	deaths = 0
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Explode(_, spellId, _, _, spellName)
	if self.db.profile.explode then
		self:IfMessage(L["explode_message"], "Urgent", spellId)
	end
	if self.db.profile.explodeBar then
		self:Bar(spellName, 4, spellId)
	end
end

function mod:Deaths(_, guid)
	if not self.db.profile.bosskill then return end
	guid = tonumber((guid):sub(-12,-7),16)
	if guid == self.guid then
		deaths = deaths + 1
	end
	if deaths == 3 then
		self:BossDeath(_, guid)
	end
end

function mod:Desecration(player)
	if player == pName and self.db.profile.desecration then
		self:LocalMessage(L["desecration"], "Personal", 67781, "Alarm")
	end
end	
