﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Eadric the Pure"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 550 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "Icecrown"
mod.zonename = BZ["Trial of the Champion"]
mod.enabletrigger = boss
mod.guid = 35119
mod.toggleOptions = {"radiance", "radianceBar", "bosskill"}

--------------------------------
--        Localization        --
--------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Eadric the Pure",
	defeat_trigger = "I yield! I submit. Excellent work. May I run away now?", -- Needs review
	hammer_message_other = "%s has the hammer!",
	hammer_message_you = "You have the hammer!",
	radiance = "Radiance",
	radianceBar = "Radiance Bar",
	radianceBar_desc = "Display a casting bar for Radiance.",
	radiance_desc = "Warn when Eadric is casting Radiance.",
	radiance_message = "Casting Radiance!",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Eadric der Reine",
	defeat_trigger = "Ich ergebe mich! Exzellente Arbeit. Darf ich jetzt wegrennen?", -- Needs review
	hammer_message_other = "%s hat den Hammer!",
	hammer_message_you = "Du hast den Hammer!",
	radiance = "Strahlen",
	radianceBar = "Strahlen-Leiste",
	radianceBar_desc = "Eine Zauberleiste für Strahlen anzeigen.",
	radiance_desc = "Warnen wenn Eadric sein Strahlen zaubert.",
	radiance_message = "Zaubert Strahlen!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Eadric le Pur",
	defeat_trigger = "Grâce ! Je me rends. Excellent travail. Puis-je me débiner, maintenant ?", -- Needs review
	hammer_message_other = "%s a le marteau !",
	hammer_message_you = "Vous avez le marteau !",
	radiance = "Radiance",
	radianceBar = "Radiance - Barre",
	radianceBar_desc = "Affiche une barre d'incantation pour Radiance.",
	radiance_desc = "Prévient quand Eadric le Pur incante Radiance.",
	radiance_message = "Radiance en incantation !",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "성기사 에드릭",
	defeat_trigger = "항복! 제가 졌습니다. 훌륭한 솜씨군요. 이제 집에 가도 되겠습니까?",
	hammer_message_other = "%s에게 정의의 망치!",
	hammer_message_you = "당신은 정의의 망치!",
	radiance = "광휘",
	radianceBar = "광휘 바",
	radianceBar_desc = "광휘의 시전바를 표시합니다.",
	radiance_desc = "에드릭의 광휘 시전을 알립니다.",
	radiance_message = "광휘 시전!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	hammer_message_other = "%s получает молот!", -- Needs review
	hammer_message_you = "Вы получаете молот!", -- Needs review
	radiance = "Сияние", -- Needs review
	radianceBar = "Полоса Сияния", -- Needs review
	radianceBar_desc = "Отображать полосу применения заклинания Сияния.", -- Needs review
	radiance_desc = "Предупреждать о применении Эдриком, Сияния.", -- Needs review
	radiance_message = "Применяется Сияние!", -- Needs review
}

end )

L:RegisterTranslations("zhCN", function() return {
	defeat_trigger = "缺失", -- Needs review
	hammer_message_other = "制裁之锤：>%s<！",
	hammer_message_you = ">你< 制裁之锤！",
	radiance = "Radiance", -- Needs review
	radianceBar = "Radiance计时条", -- Needs review
	radianceBar_desc = "当正在施放Radiance时显示计时条。", -- Needs review
	radiance_desc = "当Eadric正在施放Radiance时发出警报。", -- Needs review
	radiance_message = "正在施放 Radiance！", -- Needs review
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "『純淨者』埃卓克",
	defeat_trigger = "我認輸了!我投降。幹得好。我現在可以離場了嗎?",
	hammer_message_other = "制裁之錘：>%s<！",
	hammer_message_you = ">你< 制裁之錘！",
	radiance = "烈光",
	radianceBar = "烈光計時條",
	radianceBar_desc = "當埃卓克正在施放烈光時顯示計時條。",
	radiance_desc = "當埃卓克正在施放烈光時發出警報。",
	radiance_message = "正在施放 烈光！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_START", "radiance", 66935, 66862, 67681)
	--self:AddCombatListener("SPELL_AURA_APPLIED", "hammer", 66940)
	--self:AddCombatListener("UNIT_DIED", "BossDeath")
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:radiance(_, spellId, _, _, spellName)
	if self.db.profile.radiance then
		self:IfMessage(L["radiance_message"], "Urgent", spellId)
	end
	if self.db.profile.radianceBar then
		self:Bar(spellName, 3, spellId)
	end
end

--[[function mod:hammer(player)
	local other = fmt(L["hammer_message_other"], player)
	if player == pName and db.youhammer then

		self:LocalMessage(L["hammer_message_you"], "Personal", 66940)
		self:WideMessage(other)
	elseif db.elsehammer then
		self:IfMessage(other, "Attention", 66940)
		self:Whisper(player, L["hammer_message_you"])
	end

end]]--

function mod:CHAT_MSG_MONSTER_YELL(msg)
	if msg == L["defeat_trigger"] then
		self:BossDeath(nil, self.guid)
	end
end
