﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Grand Champions"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 550 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.zonename = BZ["Trial of the Champion"]
mod.otherMenu = "Icecrown"
mod.guid = 34657
mod.toggleOptions = {"shaman_hex", "shaman_healingwave", -1, "mage_poly", -1, "rogue_poison" , "bosskill"}

------------------------------
--      Are you local?      --
------------------------------

-- the guids of all possible grand champions.
local guids = {34657, 34701, 34702, 34703, 34705, 35569, 35570, 35571, 35572, 35617}
local deaths = 0
local pName = UnitName("player")

----------------------------
--      Localization      --
----------------------------
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	arelas = "Arelas Brightstar",
	defeat_trigger = "Well Fought!",
	jaeren = "Jaeren Sunsworn",
	mage_poly = "Mage - Polymorph",
	mage_poly_desc = "Announces who is Polymorphed.",
	mage_poly_message = "%s Polymorphed!",
	rogue_poison = "Rogue - Poison",
	rogue_poison_desc = "Warns when you are standing in poison.",
	rogue_poison_message = "Poison On You!",
	shaman_healingwave = "Shaman - Healing Wave",
	shaman_healingwave_desc = "Announces when the shaman is casting Healing Wave.",
	shaman_hex = "Shaman - Hex of Mending",
	shaman_hex_desc = "Announces who has the Hex of Mending curse.",
	shaman_hex_message = "Hex of Mending on: %s!",
}

end )

L:RegisterTranslations("deDE", function() return {
	arelas = "Arelas Hellstern",
	jaeren = "Jaeren Sonnenschwur",
	mage_poly = "Magier - Verwandlung",
	mage_poly_desc = "Kündigt an wer verwandelt ist.",
	mage_poly_message = "%s ist verwandelt!",
	rogue_poison = "Schurke - Gift",
	rogue_poison_desc = "Warnt dich wenn du im Gift stehst.",
	rogue_poison_message = "Gift auf DIR!",
	shaman_healingwave = "Schamane - Welle der Heilung",
	shaman_healingwave_desc = "Kündigt an wenn der Schamane seine Welle der Heilung zaubert.",
	shaman_hex = "Schamane - Verhexung der Heilung",
	shaman_hex_desc = "Kündigt an wer von Verhexung der Heilung betroffen ist.",
	shaman_hex_message = "Verhexung der Heilung auf: %s!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
}

end )

L:RegisterTranslations("koKR", function() return {
	arelas = "아렐라스 브라이트스타",
	jaeren = "재렌 선스원",
	mage_poly = "마법사 - 변이",
	mage_poly_desc = "변이 대상을 알립니다",
	mage_poly_message = "%s 변이됨!",
	rogue_poison = "도적 - 독",
	rogue_poison_desc = "독액 위에 있을때 알려줍니다.",
	rogue_poison_message = "당신은 독액!",
	shaman_healingwave = "주술사 - 치유의 물결",
	shaman_healingwave_desc = "주술사의 치유의 물결 시전 알림.",
	shaman_hex = "주술사 - 치유의 주술",
	shaman_hex_desc = "치유의 주술 저주 대상을 알립니다.",
	shaman_hex_message = "치유의 주술: %s!",
}

end )

L:RegisterTranslations("ruRU", function() return {
}

end )

L:RegisterTranslations("zhCN", function() return {
	arelas = "Arelas Brightstar", -- Needs review
	defeat_trigger = "Well Fought!", -- Needs review
	jaeren = "Jaeren Sunsworn", -- Needs review
	mage_poly = "法师 - 变形术",
	mage_poly_desc = "当玩家中了变形术时发出警报。",
	mage_poly_message = "变形术：>%s<！",
	rogue_poison = "潜行者 - 毒药",
	rogue_poison_desc = "当玩家站在毒药里时发出警报。",
	rogue_poison_message = ">你< 毒药！",
	shaman_healingwave = "萨满祭司 - 治疗波",
	shaman_healingwave_desc = "当萨满祭司正在施放治疗波时发出警报。",
	shaman_hex = "萨满祭司 - Hex of Mending", -- Needs review
	shaman_hex_desc = "当玩家中了Hex of Mending诅咒时发出警报。", -- Needs review
	shaman_hex_message = "Hex of Mending：>%s<！", -- Needs review
}

end )

L:RegisterTranslations("zhTW", function() return {
	arelas = "亞芮拉斯·亮星",
	defeat_trigger = "Well Fought!", -- Needs review
	jaeren = "傑倫·日誓",
	mage_poly = "法師 - 變形術",
	mage_poly_desc = "當玩家中了變形術時發出警報。",
	mage_poly_message = "變形術：>%s<！",
	rogue_poison = "盜賊 - 毒藥",
	rogue_poison_desc = "當玩家站在毒藥里時發出警報。",
	rogue_poison_message = ">你< 毒藥！",
	shaman_healingwave = "薩滿 - 治療波",
	shaman_healingwave_desc = "當薩滿正在施放治療波時發出警報。",
	shaman_hex = "薩滿 - 癒合妖術",
	shaman_hex_desc = "當玩家中了癒合妖術詛咒時發出警報。",
	shaman_hex_message = "癒合妖術：>%s<！",
}

end )

mod.enabletrigger = {L["jaeren"], L["arelas"]}

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "ShamanHexApplied", 67534)
	self:AddCombatListener("SPELL_AURA_REMOVED", "ShamanHexRemoved", 67534)
	self:AddCombatListener("SPELL_CAST_START", "ShamanHeal", 68318, 67528)
	self:AddCombatListener("SPELL_AURA_APPLIED", "MagePolyApplied", 66043, 68311)
	self:AddCombatListener("SPELL_AURA_REMOVED", "MagePolyRemoved", 66043, 68311)
	self:AddCombatListener("SPELL_AURA_APPLIED", "RoguePoisonApplied", 67701, 67594, 68316)

	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:ShamanHexApplied(player, spellId)
	if self.db.profile.shaman_hex then
		self:IfMessage(L["shaman_hex_message"]:format(player), "Attention", spellId)
		self:Bar(L["shaman_hex_message"]:format(player), 10, 67534)
	end
end

function mod:ShamanHexRemoved(player)
	if self.db.profile.shaman_hex then
		self:TriggerEvent("BigWigs_StopBar", self, L["shaman_hex_message"]:format(player))
	end
end

function mod:ShamanHeal(boss, spellId, _, _, spellName)
	if self.db.profile.shaman_healingwave then
		self:IfMessage(spellName, "Urgent", spellId)
		self:Bar(spellName, 3, 67528)
	end
end

function mod:MagePolyApplied(player, spellId)
	if self.db.profile.mage_poly then
		self:IfMessage(L["mage_poly_message"]:format(player), "Attention", spellId)
	end
end

function mod:MagePolyRemoved(player, spellId)
	if self.db.profile.mage_poly then
		self:TriggerEvent("BigWigs_StopBar", self, L["mage_poly_message"]:format(player))
	end
end

function mod:RoguePoisonApplied(player, spellId)
	if player == pName and self.db.profile.poison then
		self:LocalMessage(L["rogue_poison_message"], "Personal", spellId, "Alarm")
	end
end	

function mod:CHAT_MSG_MONSTER_YELL(msg)
	if self.db.profile.bosskill and msg:find(L["defeat_trigger"]) then
		self:BossDeath(nil, self.guid, true)
	end
end
