----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Infinite Corruptor"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 595 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.otherMenu = "Caverns of Time"
mod.zonename = BZ["The Culling of Stratholme"]
mod.enabletrigger = boss 
mod.guid = 32273
mod.toggleOptions = {"blight","blightBar","bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	blight = "Corrupting Blight",
	blightBar = "Corrupting Blight Bar",
	blightBar_desc = "Show a bar when someone receives the Corrupting Blight debuff.",
	blight_desc = "Warn when someone receives the Corrupting Blight debuff.",
	blight_message = "%s: Corrupting Blight",
	cmd = "Corruptor",
}

end )

L:RegisterTranslations("deDE", function() return {
	blight = "Verderbende Seuche",
	blightBar = "Verderbende Seuche-Anzeige",
	blightBar_desc = "Eine Leiste anzeigen wenn jemand den Debuff von Verderbende Seuche bekommt.",
	blight_desc = "Warnen wenn jemand vom Verderbende Seuche-Debuff betroffen ist.",
	blight_message = "Verderbende Seuche : %s",
	cmd = "Ewiger Verderber",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	blight = "Chancre corrupteur",
	blightBar = "Chancre corrupteur - Barre",
	blightBar_desc = "Affiche une barre quand quelqu'un subit les effets d'un Chancre corrupteur.",
	blight_desc = "Prévient quand quelqu'un subit les effets d'un Chancre corrupteur.",
	blight_message = "%s : Chancre corrupteur",
	cmd = "Corrupteur",
}

end )

L:RegisterTranslations("koKR", function() return {
	blight = "부패의 파멸 역병",
	blightBar = "부패의 파멸 역병 바",
	blightBar_desc = "부패의 파멸 역병 디버프가 생기면 바를 보여줍니다.",
	blight_desc = "부패의 파멸 역병 디버프가 생기면 알려줍니다.",
	blight_message = "%s: 부패의 파멸 역병",
	cmd = "타락자",
}

end )

L:RegisterTranslations("ruRU", function() return {
	blight = "Разъедающая гниль",
	blightBar = "Полоса Разъедающей гнили",
	blightBar_desc = "Показывать полосу если кто-то получил дебафф Разъедающей гнили.",
	blight_desc = "Сообщеть если кто-то получил дебафф Разъедающей гнили.",
	blight_message = "%s: Разъедающая гниль",
}

end )

L:RegisterTranslations("zhCN", function() return {
	blight = "腐蚀瘟疫",
	blightBar = "腐蚀瘟疫计时条",
	blightBar_desc = "当玩家中了腐蚀瘟疫减益时显示计时条。",
	blight_desc = "当玩家中了腐蚀瘟疫减益时发出警报。",
	blight_message = "腐蚀瘟疫：>%s<！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	blight = "腐化荒疫",
	blightBar = "腐化荒疫計時條",
	blightBar_desc = "當玩家中了腐化荒疫減益時顯示計時條。",
	blight_desc = "當玩家中了腐化荒疫減益時發出警報。",
	blight_message = "腐化荒疫：>%s<！",
	cmd = "恆龍墮落者",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "Blight", 60588)

	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Blight(player, spellId)
	if self.db.profile.blight then
		self:IfMessage(L["blight_message"]:format(player), "Important", spellId)
	end
	if self.db.profile.blightBar then
		self:Bar(L["blight_message"]:format(player), 120, spellId)
	end
end
